/*
 * Copyright (c) 2005 The University of Toronto and the Synthesis Group.
 * All rights reserved.
 * 
 * This file is part of the FBDD.  The FBDD is free software, also known
 * as "open source;" you can redistribute it and/or modify it under the terms
 * of the GNU General Public License (GPL), version 2, as published by the Free
 * Software Foundation (FSF).  To explore alternate licensing terms, contact
 * the University of Toronto at jzhu@eecg.toronto.edu or +1-416-946-5971.
 * 
 * The FBDD is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with the FBDD; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 */

#ifndef FBDD_H
#define FBDD_H

COM_DECLARE_CLASS( FbddManager );

typedef enum {
  FBDD_SE_MODE_FAST, 
  FBDD_SE_MODE_EXACT
} SeMode; 

#ifdef __cplusplus
extern "C" {
#endif

        extern void        fbddSetElimEnable(FbddManager fm, char val);
        extern void        fbddSetDecompEnable(FbddManager fm, char val);
        extern void        fbddSetSeEnable(FbddManager fm, char val);
        extern void        fbddSetMaxExtSize(FbddManager fm, int val);
        extern void        fbddSetSeMode(FbddManager fm, SeMode);
        extern void        fbddFinalizeOptions(FbddManager fm);

	extern FbddManager fbddNewManager( void );
	extern void        fbddDelManager(FbddManager fm);

	extern char        fbddReadBlif(FbddManager fm, char *blifFile);
	extern void        fbddWriteBlif(FbddManager fm, char *blifFile);
	extern void        fbddWriteVerilog(FbddManager fm, char *blifFile);
	extern void        fbddOptimize(FbddManager fm);

	extern void        fbddBeginModel(FbddManager fm, char *modelName);
	extern void        fbddAddPrimaryOutput(
		FbddManager fm, char *primaryOutputName
		);
	extern void        fbddAddPrimaryInput(
		FbddManager fm, char *primaryInputName
		);
	extern void        fbddAddClock(FbddManager fm, char *clockName);
	extern void        fbddBeginGate(FbddManager fm, char *outputSignal);
	extern void        fbddAddGateInput(FbddManager fm, char *inputSignal);
	extern void        fbddAddCube(FbddManager fm, char *cube);
	extern void        fbddEndGate(FbddManager fm);
	extern void        fbddAddOneConstant(FbddManager fm, char *outputSignal);
	extern void        fbddAddZeroConstant(FbddManager fm, char *outputSignal);
	extern void        fbddAddLatch(
		FbddManager fm, char *output, char *input, char *type, 
		char *control, int val
		);
	extern void        fbddEndModel(FbddManager fm);

#ifdef __cplusplus
}
#endif
	
#endif
