/********************************************************************
 *		File			:		lexicon.h
 *		Description		:		Maintaining a table of unique strings
 *		Author			:		Jianwen Zhu
 *		Email			:		jzhu@eecg.toronto.edu
 *********************************************************************/
#ifndef LEXICON_H
#define LEXICON_H

#include "com.h"

#define COM_ILEXICON_IID COM_DEFINE_GUID(	\
    0x38b8a7cd, 0xd4ae, 0x11d3, \
    0xb0, 0x07, 0x00, 0xb0, 0xd0, 0x19, 0xb1, 0x55 \
    )

COM_DECLARE_INTERFACE( Lexicon );

struct _DLexicon {
	COM_INHERIT_UNKNOWN( Lexicon );
	
	COMDECLS		(*dump)( ILexicon li, FILE* fp, char* bp );
	COMDECLP		(*create)( ILexicon li, IMem mem );
	COMDECL			(*destruct)( ILexicon li );
	COMDECL			(*construct)( ILexicon li );
	
	COMDECL			(*constructWithSize)( ILexicon li, Jint size );
	char* COMCALL	(*enter)( ILexicon li, char* s );
	char* COMCALL	(*enterLen)( ILexicon li, char* s, Jint len );
	};

#ifdef __cplusplus
class CLexicon : public CComponent {
	public:
	
	CLexicon( IGeneric i ) : CComponent( i ) {}
	CLexicon( void ) {}
	
	inline Jerror construct( Jint size ) {
		return COM_CALL( constructWithSize, (ILexicon)intf )(
			(ILexicon)intf, size
			);
		}
	inline char* enter( char* s ) {
		return COM_CALL( enter, (ILexicon)intf )( (ILexicon)intf, s );
		}
	inline char* enterLen( char* s, Jint len ) {
		return COM_CALL( enterLen, (ILexicon)intf )( (ILexicon)intf, s, len );
		}
	};
#endif

extern ILexicon		ilexicon;

#endif



