/********************************************************************
 *		File			:		imd.h
 *		Description		:		Message Digest interface
 *		Author			:		Jianwen Zhu
 *		Email			:		jzhu@eecg.toronto.edu
 *********************************************************************/
#ifndef IMD_H
#define IMD_H

#include "com.h"

typedef struct _MDID {
	Juint		digest[5];
	} *MDID;

#define COM_IMSGDIGEST_IID COM_DEFINE_GUID(0x38b8a7d9, 0xd4ae, 0x11d3, \
                                0xb0, 0x07, 0x00, 0xb0, 0xd0, 0x19, 0xb1, 0x55)

COM_DECLARE_INTERFACE( MsgDigest );

struct _DMsgDigest {
	COM_INHERIT_COMPONENT( MsgDigest );
	
	COMDECL		(*begin)( IMsgDigest mi );
	COMDECL 	(*end)( IMsgDigest mi, MDID mdid );
	COMDECL		(*update)( IMsgDigest mi, Jubyte* msg, Jint size );
	};

#ifdef __cplusplus
class CMsgDigest : public CComponent {
	public :
	CMsgDigest( IGeneric i ) : CComponent( i ) {}
	CMsgDigest( void ) {}
	
	inline Jerror begin( void ) {
		return COM_ICALL( begin, (IMsgDigest)intf )( (IMsgDigest)intf );
		}
	inline Jerror end( MDID mdid ) {
		return COM_ICALL( end, (IMsgDigest)intf )( (IMsgDigest)intf, mdid );
		}
	inline Jerror update( Jubyte* msg, Jint size ) {
		return COM_ICALL( update, (IMsgDigest)intf )(
			(IMsgDigest)intf, msg, size
			);
		}
	
	};
#endif

#define comMDConstruct( m )			COM_ICALL( construct, m )( m )
#define comMDDestruct( m )			COM_ICALL( destruct, m )( m )
#define comMDBegin( m )				COM_ICALL( begin, m )( m )
#define	comMDEnd( m, md )			COM_ICALL( end, m )( m, md )
#define comMDUpdate( m, msg, size )	COM_ICALL( update, m )( m, msg, size )
#define comMDCopy( src, dst )		( (dst)->digest[0] = (src)->digest[0], \
									  (dst)->digest[1] = (src)->digest[1], \
									  (dst)->digest[2] = (src)->digest[2], \
									  (dst)->digest[3] = (src)->digest[3], \
									  (dst)->digest[4] = (src)->digest[4] \
									  )


extern IMsgDigest	imd;

#endif
